
#
# This file is used to check if all paths are set
#

# ========== Some cache variables ==========
SET(PATH_GUILIANI "$ENV{GUILIANI_PATH}" CACHE PATH "Guiliani directory path")
SET(PATH_EGAC "$ENV{EGAC_PATH}" CACHE PATH "eGaC directory path")
SET(PATH_LIBS "$ENV{LIBS_PATH}" CACHE PATH "Libs directory path")

# try to find folders parallel to selected project

# autodetect eGaC
IF("${PATH_EGAC}" STREQUAL "")
  IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../eGaC")
    MESSAGE(STATUS "Found eGaC-folder ${CMAKE_CURRENT_SOURCE_DIR}/../eGaC")
    SET(PATH_EGAC "${CMAKE_CURRENT_SOURCE_DIR}/../eGaC" CACHE PATH "eGaC directory path" FORCE)
  ENDIF()
ENDIF()

# autodetect Guiliani
IF("${PATH_GUILIANI}" STREQUAL "")
  IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../Guiliani")
    MESSAGE(STATUS "Found Guiliani-folder ${CMAKE_CURRENT_SOURCE_DIR}/../Guiliani")
    SET(PATH_GUILIANI "${CMAKE_CURRENT_SOURCE_DIR}/../Guiliani" CACHE PATH "Guiliani directory path" FORCE)
  ENDIF()
ENDIF()

# autodetect Libs
IF("${PATH_LIBS}" STREQUAL "")
  IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../Libs")
    MESSAGE(STATUS "Found Libs-folder ${CMAKE_CURRENT_SOURCE_DIR}/../Libs")
    SET(PATH_LIBS "${CMAKE_CURRENT_SOURCE_DIR}/../Libs" CACHE PATH "Libraries directory path" FORCE)
  ELSE()
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../External")
      MESSAGE(STATUS "Found Libs-folder ${CMAKE_CURRENT_SOURCE_DIR}/../External")
      SET(PATH_LIBS "${CMAKE_CURRENT_SOURCE_DIR}/../External" CACHE PATH "Libraries directory path" FORCE)
    ENDIF()
  ENDIF()
ENDIF()

#if BLU is used the BLU path must be specified
IF(LIBS_BUILD_BLU)
  SET(PATH_BLU "$ENV{BLU_PATH}" CACHE PATH "BLU directory path")
ENDIF()

#if GlyphLib is used the GlyphLib path must be specified
IF(LIBS_BUILD_GLYPHLIB)
  SET(PATH_GLYPHLIB "$ENV{GLYPHLIB_PATH}" CACHE PATH "GlyphLib directory path")
ENDIF()

#if DAVE is used path must be specified
IF(LIBS_BUILD_DAVE)
  SET(PATH_DAVE "$ENV{DAVE_PATH}" CACHE PATH "DAVE directory path")
ENDIF()

#if FreeType shall be built from sources path must be specified
IF(LIBS_BUILD_FREETYPE)
  SET(PATH_FREETYPE "$ENV{FREETYPE_PATH}" CACHE PATH "FreeType sources path")
ENDIF()

#if libjpeg shall be built from sources path must be specified
IF(LIBS_BUILD_LIBJPEG)
  SET(PATH_LIBJPEG "$ENV{LIBJPEG_PATH}" CACHE PATH "libjpeg sources path")
ENDIF()

#if libpng shall be built from sources path must be specified
IF(LIBS_BUILD_LIBPNG)
  SET(PATH_LIBPNG "$ENV{LIBPNG_PATH}" CACHE PATH "libpng sources path")
ENDIF()

#if zlib shall be built from sources path must be specified
IF(LIBS_BUILD_ZLIB)
  SET(PATH_ZLIB "$ENV{ZLIB_PATH}" CACHE PATH "zlib sources path")
ENDIF()

# BLU
IF(GUILIANI_ADD_BLU_PLATFORM)
  SET(PATH_BLU "$ENV{BLU_PATH}" CACHE PATH "BLU directory path")
  IF(PATH_BLU STREQUAL "")
    MESSAGE(SEND_ERROR "Set Path to BLU")
  ENDIF()
ENDIF()

# GlyphLib
IF(GUILIANI_ADD_GLYPHLIB_PLATFORM)
  SET(PATH_GLYPHLIB "$ENV{GLYPHLIB_PATH}" CACHE PATH "GLYPHLIB directory path")
  IF(PATH_GLYPHLIB STREQUAL "")
    MESSAGE(SEND_ERROR "Set Path to GlyphLib")
  ENDIF()
ENDIF()

# Vulkan
IF(GUILIANI_ADD_VULKAN_PLATFORM)
  SET(PATH_VULKAN "$ENV{VULKAN_PATH}" CACHE PATH "Vulkan path")
  IF(PATH_VULKAN STREQUAL "")
    MESSAGE(SEND_ERROR "Set Path to Vulkan SDK")
  ENDIF()
ENDIF()

# check eGaC-folder
IF("${PATH_EGAC}" STREQUAL "")
  MESSAGE(FATAL_ERROR "Please set path to eGaC-folder")
ENDIF("${PATH_EGAC}" STREQUAL "")

IF(NOT EXISTS "${PATH_EGAC}/CMake/Includes.cmake")
  MESSAGE(FATAL_ERROR "Please set path to eGaC-folder")
ENDIF()

# check Guiliani-folder
IF("${PATH_GUILIANI}" STREQUAL "")
  MESSAGE(FATAL_ERROR "Please set path to Guiliani-folder")
ENDIF("${PATH_GUILIANI}" STREQUAL "")

IF(NOT EXISTS "${PATH_GUILIANI}/CMake/Includes.cmake")
  MESSAGE(FATAL_ERROR "Please set path to Guiliani-folder")
ENDIF()

# check Libs-folder
IF("${PATH_LIBS}" STREQUAL "")
  MESSAGE(FATAL_ERROR "Please set path to Libraries-folder")
ENDIF("${PATH_LIBS}" STREQUAL "")
