
#
# This is the Platform.cmake file.
#

IF("${CMAKE_PLATFORM_NAME}" STREQUAL "")
    SET(CMAKE_INCLUDE_FILE "${CMAKE_SYSTEM_NAME}-${CMAKE_CXX_COMPILER_ID}-${CMAKE_SYSTEM_PROCESSOR}.cmake")
ELSE("${CMAKE_PLATFORM_NAME}" STREQUAL "")
    SET(CMAKE_INCLUDE_FILE "${CMAKE_SYSTEM_NAME}-${CMAKE_CXX_COMPILER_ID}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_PLATFORM_NAME}.cmake")
ENDIF("${CMAKE_PLATFORM_NAME}" STREQUAL "")

IF(EXISTS "${PATH_COMMON}/Platform/${CMAKE_INCLUDE_FILE}")
    INCLUDE("${PATH_COMMON}/Platform/${CMAKE_INCLUDE_FILE}")
ELSE(EXISTS "${PATH_COMMON}/Platform/${CMAKE_INCLUDE_FILE}")
    MESSAGE(FATAL_ERROR "common platform-file not found: ${PATH_COMMON}/Platform/${CMAKE_INCLUDE_FILE}")
ENDIF(EXISTS "${PATH_COMMON}/Platform/${CMAKE_INCLUDE_FILE}")

IF(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/${CMAKE_INCLUDE_FILE}")
    # check for cmake-file with correct name
    INCLUDE("${PROJECT_SOURCE_DIR}/CMake/Platform/${CMAKE_INCLUDE_FILE}")
ELSE(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/${CMAKE_INCLUDE_FILE}")
    # check for template-cmake-file
    IF(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/template.cmake")
        MESSAGE(STATUS "CMake-file with platform does not exist, using template.cmake")
        INCLUDE("${PROJECT_SOURCE_DIR}/CMake/Platform/template.cmake")
    ELSE(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/template.cmake")
        MESSAGE(FATAL_ERROR "platform-file not found: ${PROJECT_SOURCE_DIR}/CMake/Platform/${CMAKE_INCLUDE_FILE}")
    ENDIF(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/template.cmake")
ENDIF(EXISTS "${PROJECT_SOURCE_DIR}/CMake/Platform/${CMAKE_INCLUDE_FILE}")
