# include directories
# NO platform specific include directories

# common folders
TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
  PRIVATE "${PATH_GUILIANI}/Include/Core"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Behaviour"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Command"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Control"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Exception"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Layouter"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Transition"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Utils"
  PRIVATE "${PATH_GUILIANI}/Include/Core/Video"
  PRIVATE "${PATH_GUILIANI}/Include/CustomExtension"
  PRIVATE "${PATH_GUILIANI}/Include/GUIConfig"
  PRIVATE "${PATH_GUILIANI}/Include/ImageDecoder"
  PRIVATE "${PATH_GUILIANI}/Include/Platform/general"
)

IF(GUILIANI_PACKAGE_ADD_ANIMATION)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Core/Animation"
  )
ENDIF()

IF(GUILIANI_PACKAGE_ADD_CONNECTION)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Connection"
  )
ENDIF()

IF(GUILIANI_PACKAGE_ADD_STREAMING)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Core/Streaming"
  )
ENDIF()

IF(GUILIANI_ADD_BLU_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/BLU"
  )

  IF(STREAMRUNTIME_SDK_PROJECT)
    TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${PATH_GUILIANI}/../BLU/Include/BLU"
    )
  ELSE()
    TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${PATH_BLU}/Include"
    )
  ENDIF()
ENDIF()

IF(GUILIANI_ADD_DAVE_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/DAVE"
  )
ENDIF()

IF(GUILIANI_ADD_EGML_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/eGML"
  )
ENDIF()

IF(GUILIANI_ADD_DAVEHD_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/DAVE"
    PRIVATE "${PATH_GUILIANI}/Include/Platform/DAVEHD"
  )
ENDIF()

IF(GUILIANI_ADD_GL_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/GL"
  )
ENDIF()

IF("${GUILIANI_OGL_PLATFORM}" STREQUAL "OpenGL")
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/GL/OGL"
  )
ELSEIF("${GUILIANI_OGL_PLATFORM}" STREQUAL "OpenGL ES 1.1")
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/GL/OGLES"
  )
ELSEIF("${GUILIANI_OGL_PLATFORM}" STREQUAL "OpenGL ES 2.0")
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/GL/OGLES"
  )
ENDIF("${GUILIANI_OGL_PLATFORM}" STREQUAL "OpenGL")

IF(GUILIANI_ADD_VULKAN_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/Platform/Vulkan"
  )
ENDIF()

IF(GUILIANI_ADD_GLYPHLIB_PLATFORM)
  IF(STREAMRUNTIME_SDK_PROJECT)
    TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${PATH_GUILIANI}/../GlyphLib/Include"
    )
  ELSE()
    TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${PATH_GLYPHLIB}/Include"
    )
  ENDIF()
ENDIF()

IF(GUILIANI_ADD_IMAGE_DECODER)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_GUILIANI}/Include/ImageDecoder"
    PRIVATE "${PATH_LIBS}/nanosvg/include"
    PRIVATE "${PATH_LIBS}/webp/include"
  )
ENDIF()
