#ifndef __GUIINPUTCALIBRATION_H__
#define __GUIINPUTCALIBRATION_H__

#include "eC_Types.h"
#include "GUI.h"

#include "GfxWrap.h"

#include "GUICommandHandler.h"
#include "GUIQuitCmd.h"

/** this class is used for calibrating the input-device
*/
class CGUIInputCalibration : public CGUI
{
public:
    /** constructor
    @param uiWidth width
    @param uiHeight
    */
    CGUIInputCalibration(const eC_UInt& uiWidth, const eC_UInt& uiHeight);

    virtual eC_Bool DoClick(const eC_Value& vPosX, const eC_Value& vPosY);

    virtual eC_Bool DoDraw();

    /** get size of input-device
    @param riSizeX width
    @param riSizeY height
    */
    void GetSize(eC_Int& riSizeX, eC_Int& riSizeY);

    /** get offset of input-device
    @param riOffsetX x-offset
    @param riOffsetY y-offset
    */
    void GetOffset(eC_Int& riOffsetX, eC_Int& riOffsetY);

private:
    eC_UByte m_ubDotSize;
    eC_UByte m_ubNumberOfClicks;
    eC_Value m_vXPos[2];
    eC_Value m_vYPos[2];
};
#endif
