/*
* Copyright (C) TES Electronic Solutions GmbH,
* All Rights Reserved.
* Contact: info@guiliani.de
*
* This file is part of the Guiliani HMI framework
* for the development of graphical user interfaces on embedded systems.
*/

#ifndef GUI_COLOR_RESOURCE__H_
#define GUI_COLOR_RESOURCE__H_
#include "eC_Types.h"
#include <limits.h>

/// @file GUIColorResource.h @ref page_helpermacros
// 
// DO NOT EDIT THIS FILE!!! Add your own IDS within UserXXXResource.h files!
// DO NOT EDIT THIS FILE!!! Add your own IDS within UserXXXResource.h files!
// DO NOT EDIT THIS FILE!!! Add your own IDS within UserXXXResource.h files!
//

// -----------------------------------------------------------------------------------------
///  Color resources

#define COLOR_TABLE \
ENTRY(DUMMY_COLOR, 0xff000000)

// Calculate the value for the START_TAG used in th enum definition below.
#define ENTRY_ENUM(a) -1 ///< \ref page_helpermacros
#define ENTRY(color, value) -1///< \ref page_helpermacros
const int ciCalculatedColorStartTag = COLOR_TABLE;///< preprocessor generates for all entries of COLOR_TABLE: -1 -1 -1..., resulting in a mathematical expression, that will be evaluated to -1*(Number of entries of COLOR_TABLE 
#undef ENTRY
#undef ENTRY_ENUM

#ifndef GUILIANI_GUILIANILIB
#include "UserColorResource.h"
#endif

/// List of color-resource ids.
enum ColorResource_t
{
    COLOR_START_TAG = ciCalculatedColorStartTag,
#define ENTRY_ENUM(a) a, ///< \ref page_helpermacros
#define ENTRY(color, value) color, ///< \ref page_helpermacros
    COLOR_TABLE
#ifndef GUILIANI_GUILIANILIB
    USER_COLOR_TABLE
#endif
#undef ENTRY
#undef ENTRY_ENUM
    NOF_COLORRESOURCES,
    GUILIANI_INTERNAL_COLORRESOURCE = INT_MAX // Do not touch this. Required for ensuring consistent enum type size across libraries.
};

// Check if the DUMMY value is always 0. If not compile error!
///< Will throw compile error negative subscript if DUMMY_COLOR is NOT 0!
typedef int static_assert_something[(DUMMY_COLOR == 0) ? 1 : -1];

/// Map ColorResource_t to interval 0 to NOF_COLORRESOURCES
#define MAP_COLORID_TO_ARRAY(COLOR_ID) static_cast<eC_UInt>(COLOR_ID-COLOR_START_TAG-1)
/// Unmap ColorResource_t from interval 0 to NOF_COLORRESOURCES
#define UNMAP_COLORENTRY_TO_ARRAY(COLOR_ENTRY) static_cast<ColorResource_t>(COLOR_ENTRY+COLOR_START_TAG+1)
// Amount of resources.
extern const eC_UInt cuiNOFColorResources; ///< Used to contain the highest index cuiNOFXXXClasses = MAP_PROPID_TO_ARRAY(NOF_XXXCLASSES);

#endif
