/*
* Copyright (C) TES Electronic Solutions GmbH,
* All Rights Reserved.
* Contact: info@guiliani.de
*
* This file is part of the Guiliani HMI framework
* for the development of graphical user interfaces on embedded systems.
*/

#ifndef __GFX_ENV_NULL_H__
#define __GFX_ENV_NULL_H__

#include "GfxEnv.h"

#include "GUILayerConfig.h"

class CGfxWrap;
class CGUIObject;

/**
    This is the NULL-implementation of an Gfx-Environment

    @ingroup GUILIANI_GRAPHICS
*/
class CGfxEnvNull : public CGfxEnv
{
public:
    /// Destructor
    virtual ~CGfxEnvNull(void) {}

    CGfxEnvNull() :
        CGfxEnv(SM_FRAMEBUFFER, CGUICommonEnums::RGB_565, 0, 0)
    {}

    eC_Bool IsNull() { return true; }

private:
    /** Copy-constructor.
        @param kSource Source object to be copied.
    */
    CGfxEnvNull(const CGfxEnvNull& kSource);

    /** Operator= method.
        @param kSource Source object to be copied.
        @return This instance.
    */
    CGfxEnvNull& operator=(const CGfxEnvNull& kSource);
};

#endif
