/*
* Copyright (C) TES Electronic Solutions GmbH,
* All Rights Reserved.
* Contact: info@guiliani.de
*
* This file is part of the Guiliani HMI framework
* for the development of graphical user interfaces on embedded systems.
*/

#include "eC_String.h"
#include "GUIAnimationResource.h"
#include "GUIBehaviourResource.h"
#include "GUICommandResource.h"
#include "GUIControlResource.h"
#include "GUIFontResource.h"
#include "GUIImageResource.h"
#include "GUIGeneralResource.h"
#include "GUILayouterResource.h"
#include "GUILocaleResource.h"
#include "GUIObjectHandleResource.h"
#include "GUIPropertyResource.h"
#include "GUISoundResource.h"
#include "GUITextResource.h"
#include "GUIDataPoolResource.h"
#include "GUIColorResource.h"

/*
##################################################################################
                    DO NOT EDIT THIS FILE !!!!
##################################################################################
*/

// -----------------------------------------------------------------------------------------
// global properties

const eC_UInt cuiNOFGlobalProperties = MAP_PROPID_TO_ARRAY(NOF_PROPERTIES);

// -----------------------------------------------------------------------------------------
//  font resources

const eC_UInt cuiNOFFontResources = MAP_FNTID_TO_ARRAY(NOF_FONTRESOURCES);

// -----------------------------------------------------------------------------------------
//  image resources

const eC_UInt cuiNOFImageResources = MAP_IMGID_TO_ARRAY(NOF_IMAGERESOURCES);

// -----------------------------------------------------------------------------------------
//  text resources

const eC_UInt cuiNOFTextResources = MAP_TEXTID_TO_ARRAY(NOF_TEXTRESOURCES);

// -----------------------------------------------------------------------------------------
// sound resources

const eC_UInt cuiNOFSoundResources = MAP_SNDID_TO_ARRAY(NOF_SOUNDRESOURCES);

// -----------------------------------------------------------------------------------------
//  Object Handles

const eC_UInt cuiNOFObjectHandles = MAP_OBJID_TO_ARRAY(NOF_OBJECTHANDLES);

// -----------------------------------------------------------------------------------------
//  locale Handles

const eC_UInt cuiNOFLocaleHandles = MAP_PROPID_TO_ARRAY(NOF_LOCALEHANDLES);

// -----------------------------------------------------------------------------------------
//  command Handles

const eC_UInt cuiNOFCommandClasses = MAP_PROPID_TO_ARRAY(NOF_COMMANDCLASSES);

// -----------------------------------------------------------------------------------------
//  general resource file Handles

const eC_UInt cuiNOFGeneralResources = MAP_RESID_TO_ARRAY(NOF_GENERALRESOURCES);

// -----------------------------------------------------------------------------------------
//  DataPool resource Handles

const eC_UInt cuiNOFDataPoolResources = MAP_DATAPOOLID_TO_ARRAY(NOF_DATAPOOLRESOURCES);

// -----------------------------------------------------------------------------------------
//  Color resource Handles

const eC_UInt cuiNOFColorResources = MAP_COLORID_TO_ARRAY(NOF_COLORRESOURCES);

// -----------------------------------------------------------------------------------------
//  Animation Handles

const eC_UInt cuiNOFAnimationHandles = MAP_ANIMID_TO_ARRAY(NOF_ANIMATIONIDS);
