#include "CustomExtensionFactory.h"
#include "GUIComponentManager.h"

#include "GUI.h"

#define PLUGIN_VERSION 1

extern "C" LINKAGE void InitPlugin(CGUIComponentManager* pkCompMan)
{
    CGUIComponentManager::GetInstance().SetInstances(pkCompMan);
}

extern "C" LINKAGE void RegisterExtensions(CustomExtensionFactory* pkCustomExtensionsFactory)
{
    ControlVector kControls;
    GETEXTENSIONSFACTORY->GetControls(kControls);
    for (eC_UInt uiIndex = 0; uiIndex < kControls.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterControl(kControls[uiIndex]);
    }

    BehaviourVector kBehaviours;
    GETEXTENSIONSFACTORY->GetBehaviours(kBehaviours);
    for (eC_UInt uiIndex = 0; uiIndex < kBehaviours.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterBehaviour(kBehaviours[uiIndex]);
    }

    CommandVector kCommand;
    GETEXTENSIONSFACTORY->GetCommands(kCommand);
    for (eC_UInt uiIndex = 0; uiIndex < kCommand.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterCommand(kCommand[uiIndex]);
    }

    LayouterVector kLayouters;
    GETEXTENSIONSFACTORY->GetLayouters(kLayouters);
    for (eC_UInt uiIndex = 0; uiIndex < kLayouters.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterLayouter(kLayouters[uiIndex]);
    }

    TextTypeVector kTextTypes;
    GETEXTENSIONSFACTORY->GetTextTypes(kTextTypes);
    for (eC_UInt uiIndex = 0; uiIndex < kTextTypes.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterText(kTextTypes[uiIndex]);
    }

#ifdef GUILIANI_ANIMATION_ACTIVE
    AnimationVector kAnimations;
    GETEXTENSIONSFACTORY->GetAnimations(kAnimations);
    for (eC_UInt uiIndex = 0; uiIndex < kAnimations.GetQuantity(); ++uiIndex)
    {
        pkCustomExtensionsFactory->RegisterAnimation(kAnimations[uiIndex]);
    }
#endif
}

extern "C" LINKAGE char* GetMem()
{
    char* pi = new char[100];
    return pi;
}

extern "C" LINKAGE eC_UInt GetVersion()
{
    return (eC_UInt)PLUGIN_VERSION;
}

extern "C" LINKAGE eC_UInt GetGuilianiVersion()
{
    return CGUI::GetVersion();
}

extern "C" LINKAGE eC_UInt GetCompilerVersion()
{
#if defined(eC_TARGET_COMPILER_MSVC)
    return 1;
#elif defined(eC_TARGET_COMPILER_GCC)
    return 2;
#else
    return 0;
#endif
}

extern "C" LINKAGE eC_UInt GetBuildVersion()
{
#if defined(_DEBUG) || defined(DEBUG)
    return 1;
#else
    return 0;
#endif
}
