#if defined(eC_TARGET_ENV_WIN32)

#include <Windows.h>

/***********************************************************************
* Function: operator new
************************************************************************/
void *operator new (size_t size)
{
    return GlobalAlloc(0, size);
}

/***********************************************************************
* Function: operator delete
************************************************************************/
void operator delete (void *p)
{
    GlobalFree(p);
}

/***********************************************************************
* Function: operator new []
************************************************************************/
void *operator new [](size_t size)
{
    return GlobalAlloc(0, size);
}

/***********************************************************************
* Function: operator delete []
************************************************************************/
void operator delete[](void *p)
{
    GlobalFree(p);
}

#else

#include "eC_Platform.h"

/***********************************************************************
* Function: operator new
************************************************************************/
void *operator new (size_t size)
{
    return eC_Malloc(size);
}

/***********************************************************************
* Function: operator delete
************************************************************************/
void operator delete (void *p)
{
    eC_Free(p);
}

/***********************************************************************
* Function: operator new []
************************************************************************/
void *operator new [](size_t size)
{
    return eC_Malloc(size);
}

/***********************************************************************
* Function: operator delete []
************************************************************************/
void operator delete[](void *p)
{
    eC_Free(p);
}

#endif
