/**
 * @file m13_ra6m3_ek_ethernet.c
 * @brief M13-RA6M3-EK Ethernet definition
 *
 * @section License
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright (C) 2020-2021 M13DESIGN SARL. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @author M13DESIGN SARL (www.m13design.fr)
 * @version 1.0.0
 **/

#include "m13_ra6m3_ek_pinout.h"
#include "m13_ra6m3_ek_ethernet.h"

//Ethernet IOPORT structure
static ioport_instance_ctrl_t eth_pin_ctrl;

// Macro definitions


/**
 * @name       bsp_ethernet_init
 * @brief      Configure M13-RA6M3-EK Ethernet pins
 * @param[in]  None
 * @return     None
 */
void bsp_ethernet_init(void)
{
    ioport_cfg_t eth_pin_cfg;

    eth_pin_cfg.number_of_pins = sizeof(m13_ra6m3_ek_eth_pin_data)/sizeof(ioport_pin_cfg_t);
    eth_pin_cfg.p_pin_cfg_data = &m13_ra6m3_ek_eth_pin_data[0];

    //Configure led pins
    R_IOPORT_Open(&eth_pin_ctrl, &eth_pin_cfg);
}
