/**
 * @file m13_ra6m3_ek_led.h
 * @brief m13_ra6m3_ek led BSP
 *
 * @section License
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Copyright (C) 2020-2021 M13DESIGN SARL. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @author M13DESIGN SARL (www.m13design.fr)
 * @version 1.0.0
 **/

#ifndef _M13_RA6M3_EK_LED_H
#define _M13_RA6M3_EK_LED_H

// Dependencies
#include "r_ioport.h"


// typedef definitions
typedef enum
{
    BSP_LED1 = BSP_IO_PORT_00_PIN_10,
    BSP_LED2 = BSP_IO_PORT_00_PIN_09,
    BSP_LED3 = BSP_IO_PORT_00_PIN_08,
} bsp_led_channel_t;

typedef enum
{
    BSP_LED_STATE_OFF = BSP_IO_LEVEL_LOW,
    BSP_LED_STATE_ON  = BSP_IO_LEVEL_HIGH,
} bsp_led_state_t;

// BSP Functions
void bsp_led_io_init (void);
void bsp_led_on (bsp_led_channel_t led_number);
void bsp_led_off (bsp_led_channel_t led_number);
bsp_led_state_t bsp_led_get_state (bsp_led_channel_t led_number);

#endif

