#include "m13_ra6m3_ek_acc.h"
#include "m13_ra6m3_ek_vcom.h"
#include "freertos.h"
#include "semphr.h"

int16_t ax;
int16_t ay;
int16_t az;
extern SemaphoreHandle_t i2c_channel_0_semaphore;

/* MEMS Thread entry function */
/* pvParameters contains TaskHandle_t */
extern void accelerometer_task(void *parameters)
{
    FSP_PARAMETER_NOT_USED (parameters);

    while (1)
    {
        xSemaphoreTake(i2c_channel_0_semaphore, portMAX_DELAY);

        //Retrieve acceleration along the 3 axis
        bsp_acc_get_acc(&ax, &ay, &az);

        xSemaphoreGive(i2c_channel_0_semaphore);

        //Loop delay
        vTaskDelay (200);
    }
}
