# ========== Include defines ==========
INCLUDE("${PATH_COMMON}/Global_Defines.cmake")

# ========== Include correct platform file ==========
INCLUDE("${PATH_COMMON}/Platform.cmake")

# ========== Include libraries ==========
INCLUDE("${PATH_COMMON}/AddLibs.cmake")

# ========== Set wrapper definitions ==========
INCLUDE("CMake/GfxEnv.cmake")

# ========== Set include directories ==========
INCLUDE("${PATH_COMMON}/Include_directories.cmake")

# ========== Output some information ==========
INCLUDE("${PATH_COMMON}/Build_information.cmake")

IF(NOT GSE_PROJECT)
  IF(SDK_PACKAGE_INCLUDE_DOCUMENTATION)
    # documentation
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../Documentation/CPackPackages.cmake")
      INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/../Documentation/CPackPackages.cmake)
    ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../Documentation/CPackPackages.cmake")
  ENDIF()

  # add common to package
  IF(EXISTS "${PATH_COMMON}/CPackPackages.cmake")
    INCLUDE (${PATH_COMMON}/CPackPackages.cmake)
  ENDIF(EXISTS "${PATH_COMMON}/CPackPackages.cmake")

  # add Libs to package
  IF(EXISTS "${PATH_LIBS}/CPackPackages.cmake")
    INCLUDE (${PATH_LIBS}/CPackPackages.cmake)
  ENDIF(EXISTS "${PATH_LIBS}/CPackPackages.cmake")
  
  # add own package-file
  IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/CPackConfiguration.cmake")
    INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CPackConfiguration.cmake)
  ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/CPackConfiguration.cmake")
ENDIF(NOT GSE_PROJECT)

IF(SDK_PACKAGE_GENERATOR AND (SDK_PACKAGE_INCLUDE_HOST OR SDK_PACKAGE_INCLUDE_TARGET))
  INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CPackPackages.cmake OPTIONAL)
ENDIF()
