# provide selection-boxes and set definitions for GfxEnv

SET(STREAMRUNTIME_GFXENV "FBDEV" CACHE STRING "use which GfxEnv?")
set_property(CACHE STREAMRUNTIME_GFXENV PROPERTY STRINGS FBDEV DRM WAYLAND)

SET(STREAMRUNTIME_GFXWRAP "EGML" CACHE STRING "use which GfxWrap?")
set_property(CACHE STREAMRUNTIME_GFXWRAP PROPERTY STRINGS EGML BLU GL GLES DAVE DAVEHD VULKAN)

SET(STREAMRUNTIME_FNTWRAP "FREETYPE" CACHE STRING "use which FntWrap?")
set_property(CACHE STREAMRUNTIME_FNTWRAP PROPERTY STRINGS FREETYPE GLYPHLIB EGML)

SET(STREAMRUNTIME_COLORFORMAT "RGB565" CACHE STRING "use which color-format?")
set_property(CACHE STREAMRUNTIME_COLORFORMAT PROPERTY STRINGS ARGB32 RGB888 RGB565 LUM8)

IF("${STREAMRUNTIME_GFXENV}" STREQUAL "FBDEV")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_FBDEV")
ELSEIF("${STREAMRUNTIME_GFXENV}" STREQUAL "DRM")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_DRM")
ELSEIF("${STREAMRUNTIME_GFXENV}" STREQUAL "WAYLAND")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_WAYLAND")
ENDIF()

IF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "BLU")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_BLU")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "EGML")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_EGML")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "GL")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_GL")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "GLES")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_GLES")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "DAVE")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_DAVE")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "DAVEHD")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_DAVEHD")
ELSEIF("${STREAMRUNTIME_GFXWRAP}" STREQUAL "VULKAN")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_VULKAN")
ENDIF()

IF("${STREAMRUNTIME_FNTWRAP}" STREQUAL "FREETYPE")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "FNT_USE_FREETYPE")
ELSEIF("${STREAMRUNTIME_FNTWRAP}" STREQUAL "GLYPHLIB")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "FNT_USE_GLYPHLIB")
ELSEIF("${STREAMRUNTIME_FNTWRAP}" STREQUAL "EGML")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "FNT_USE_EGML")
ENDIF()

IF("${STREAMRUNTIME_COLORFORMAT}" STREQUAL "ARGB32")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_ARGB32")
ELSEIF("${STREAMRUNTIME_COLORFORMAT}" STREQUAL "RGB888")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_RGB888")
ELSEIF("${STREAMRUNTIME_COLORFORMAT}" STREQUAL "RGB565")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_RGB565")
ELSEIF("${STREAMRUNTIME_COLORFORMAT}" STREQUAL "LUM8")
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_LUM8")
ENDIF()

IF(GUILIANI_USE_SDL2_PLATFORM)
    LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION "GFX_USE_SDL2")
ENDIF()

LIST(APPEND STREAMRUNTIME_WRAPPER_DEFINITION ${GUILIANI_OGL_VERSION})
