
#
# FreeRTOS-GNU-arm-ra6m3_m13 specific settings
#

# set outputs
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_SOURCE_DIR}/Binary/${CMAKE_SYSTEM_NAME}/${CMAKE_PLATFORM_NAME}/${CMAKE_CXX_COMPILER_ID}/${CMAKE_BUILD_TYPE}")

# include directories
TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
  PRIVATE "${PROJECT_SOURCE_DIR}/Common/Include/Platform/FreeRTOS"
  PRIVATE "${PROJECT_SOURCE_DIR}/Common/Include/Platform/ra6m3"
)

TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/arm/CMSIS_5/CMSIS/Core/Include"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/aws/FreeRTOS/FreeRTOS/Source/include"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/inc"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/inc/api"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/inc/instances"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/src/bsp/cmsis/Device/RENESAS/Include"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/src/bsp/mcu/all"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/src/bsp/mcu/ra6m3"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/src/rm_freertos_port"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/fsp/src/r_drw"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra/tes/dave2d/inc"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra_cfg/aws"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra_cfg/driver"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra_cfg/fsp_cfg"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra_cfg/fsp_cfg/bsp"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/ra_gen"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/src"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/src/m13design"
  PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/src/m13design/font"
)

IF(STREAMRUNTIME_SDK_PROJECT)
  # Some platform depenant include directories.
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_EGAC}/Include/eGML/eGML_RZA1H"
    PRIVATE "${PATH_EGAC}/Include/eC/FreeRTOS"
    PRIVATE "${PATH_EGAC}/Include/eC/RZA1H"
  )
ENDIF()

# source files
FILE(GLOB PLATFORM_COMMON_RA_CPP
  "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/StreamRuntime.cpp"
  "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/StreamRuntimeStartup.cpp"
)

FILE(GLOB PLATFORM_RA_CPP
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/new_delete.cpp"
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/StreamRuntime.cpp"
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/StreamRuntime_RA6M3_Funcs.cpp"
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/FreeRTOS/StreamRuntime_RA6M3_main.cpp"
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/ra6m3/GUIInputRA6M3.cpp"
    "${PROJECT_SOURCE_DIR}/Common/Source/Platform/ra6m3/GfxEnvRA6M3.cpp"
)

SET(PLATFORM_FILES 
    ${PLATFORM_RA_CPP}
    ${PLATFORM_COMMON_RA_CPP}
    ${SYSCALLS_C}
)

IF(STREAMRUNTIME_SDK_PROJECT)
    TARGET_LINK_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${CMAKE_BINARY_DIR}"
    )
ELSE()
    TARGET_LINK_DIRECTORIES(${PROJECT_NAME}
      PRIVATE "${CMAKE_BINARY_DIR}"
      PRIVATE "${CMAKE_BSP_SUBDIRECTORY}/${CMAKE_BUILD_TYPE}"
    )
ENDIF()

# FREETYPE
IF(GUILIANI_ADD_FREETYPE_PLATFORM)
  TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_LIBS}/freetype/include"
  )

  TARGET_LINK_DIRECTORIES(${PROJECT_NAME}
    PRIVATE "${PATH_LIBS}/freetype/lib"
  )

  LIST(APPEND PLATFORM_LIBS
    "freetype"
  )
ENDIF()

# BSP-folder is not added since we use a prebuilt library
#ADD_SUBDIRECTORY(${CMAKE_BSP_SUBDIRECTORY} ./BSP)

LIST(APPEND PLATFORM_LIBS
    "BSP"
)

SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LINKER_SCRIPT}")

ADD_CUSTOM_TARGET(PostBuildTarget ALL
  COMMAND "${CMAKE_OBJCOPY}" --verbose -O binary $<TARGET_FILE:${PROJECT_NAME}> $<TARGET_FILE_DIR:${PROJECT_NAME}>/${PROJECT_NAME}.bin
  COMMAND "${TOOLCHAIN}/arm-none-eabi-size" $<TARGET_FILE:${PROJECT_NAME}>
  COMMENT "create binary file"
  DEPENDS ${PROJECT_NAME}
)
